// PPgLists.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgLists.h"
#include "IP2Country.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgLists dialog

IMPLEMENT_DYNAMIC(CPPgLists, CPropertyPage)
CPPgLists::CPPgLists()
	: CPropertyPage(CPPgLists::IDD)
	, showA4AF(FALSE)
	, showA4AFCount(FALSE)
	, showAvgDataRate(FALSE)
	, showFileTypeIcons(FALSE)
	, showTransferredOnCompleted(FALSE)
	, showDownloadPercentage(FALSE)
	, showPausedGray(FALSE)
	, showFileStatusIcons(FALSE)
	, showCountryFlag(FALSE)
	, roundSizes(FALSE)
	, displayUploadParts(FALSE)
	, strSmartFilterDesc(_T(""))
	, strSmartFilterMaxQR(_T(""))
	, strFakeListColorLabel(_T(""))
	, bSmartFilterShowSourcesOQ(FALSE)
	, showRatingIcons(FALSE)
{
}

CPPgLists::~CPPgLists()
{
}

void CPPgLists::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_A4AF, showA4AF);
	DDX_Check(pDX, IDC_A4AFCOUNT, showA4AFCount);
	DDX_Check(pDX, IDC_SHOWAVGDATARATE, showAvgDataRate);
	DDX_Check(pDX, IDC_SHOWFTYPE, showFileTypeIcons);
	DDX_Check(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompleted);
	DDX_Check(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentage);
	DDX_Check(pDX, IDC_SHOWGRAY, showPausedGray);
	DDX_Check(pDX, IDC_STATUSICONS, showFileStatusIcons);
	DDX_Check(pDX, IDC_TBSSHOWCOUNTRYFLAG, showCountryFlag);
	DDX_Check(pDX, IDC_ROUNDSIZES, roundSizes);
	DDX_Check(pDX, IDC_UPLOADPARTS, displayUploadParts);
	DDX_Control(pDX, IDC_A4AF, showA4AFCheck);
	DDX_Control(pDX, IDC_A4AFCOUNT, showA4AFCountCheck);
	DDX_Control(pDX, IDC_SHOWAVGDATARATE, showAvgDataRateCheck);
	DDX_Control(pDX, IDC_SHOWFTYPE, showFileTypeIconsCheck);
	DDX_Control(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompletedCheck);
	DDX_Control(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentageCheck);
	DDX_Control(pDX, IDC_SHOWGRAY, showPausedGrayCheck);
	DDX_Control(pDX, IDC_STATUSICONS, showFileStatusIconsCheck);
	DDX_Control(pDX, IDC_TBSSHOWCOUNTRYFLAG, showCountryFlagCheck);
	DDX_Control(pDX, IDC_ROUNDSIZES, roundSizesCheck);
	DDX_Control(pDX, IDC_UPLOADPARTS, displayUploadPartsCheck);	
	DDX_Text(pDX, IDC_SMARTFILTERGROUPBOX, strSmartFilterDesc);
	DDX_Control(pDX, IDC_SMARTFILTERMAXQRLBL, SmartFilterMaxQRLabel);
	DDX_Text(pDX, IDC_SMARTFILTERMAXQR, strSmartFilterMaxQR);
	DDX_Text(pDX, IDC_FAKELIST_COLOR_STATIC, strFakeListColorLabel);
	DDX_Control(pDX, IDC_SMARTFILTERMAXQR, SmartFilterMaxQREdit);
	DDX_Check(pDX, IDC_SMARTFILTERSHOWOQ, bSmartFilterShowSourcesOQ);
	DDX_Control(pDX, IDC_SMARTFILTERSHOWOQ, SmartFilterShowSourcesOQCheck);
	DDX_Check(pDX, IDC_SHOWRATINGICONS, showRatingIcons);
	DDX_Control(pDX, IDC_SHOWRATINGICONS, showRatingIconsCheck);
	DDX_Control(pDX, IDC_COLOR_BUTTON, m_FakeListColorButton);
}

BEGIN_MESSAGE_MAP(CPPgLists, CPropertyPage)
	ON_BN_CLICKED(IDC_A4AF, OnSettingsChange)
	ON_BN_CLICKED(IDC_A4AFCOUNT, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWAVGDATARATE, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWFTYPE, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWTRANFONCMPLT, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWDWLPERCENTAGE, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWGRAY, OnSettingsChange)
	ON_BN_CLICKED(IDC_STATUSICONS, OnSettingsChange)
	ON_BN_CLICKED(IDC_TBSSHOWCOUNTRYFLAG, OnSettingsChange)
	ON_BN_CLICKED(IDC_ROUNDSIZES, OnSettingsChange)
	ON_EN_CHANGE(IDC_SMARTFILTERMAXQR, OnSettingsChange)
	ON_BN_CLICKED(IDC_SMARTFILTERSHOWOQ, OnSettingsChange)
	ON_BN_CLICKED(IDC_SHOWRATINGICONS, OnSettingsChange)
	ON_BN_CLICKED(IDC_UPLOADPARTS, OnSettingsChange)
	ON_MESSAGE(CPN_SELCHANGE, OnColorButtonSelChange)
END_MESSAGE_MAP()

BOOL CPPgLists::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_FakeListColorButton.SetDefaultColor(0);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgLists::LoadSettings(void)
{
	showA4AF = m_pPrefs->IsA4AFStringEnabled();
	showA4AFCount = m_pPrefs->IsA4AFCountEnabled();
	showAvgDataRate = m_pPrefs->GetShowAverageDataRate();
	showFileTypeIcons = m_pPrefs->ShowFileTypeIcon();
	showTransferredOnCompleted = m_pPrefs->IsTransferredOnCompleted();
	showDownloadPercentage = m_pPrefs->GetUseDwlPercentage();
	showPausedGray = m_pPrefs->ShowPausedGray();
	showFileStatusIcons = m_pPrefs->ShowFullFileStatusIcons();
	showCountryFlag = m_pPrefs->GetShowCountryFlag();
	roundSizes = m_pPrefs->ShowRoundSizes();
	displayUploadParts = m_pPrefs->IsUploadPartsEnabled();
	strSmartFilterMaxQR.Format(_T("%u"), m_pPrefs->GetSmartFilterMaxQueueRank());
	bSmartFilterShowSourcesOQ = m_pPrefs->GetSmartFilterShowOnQueue();
	showRatingIcons = m_pPrefs->ShowRatingIcons();
	m_FakeListColorButton.SetColor(m_pPrefs->GetFakeListDownloadColor());

	UpdateData(FALSE);

	SetModified(FALSE);
}

BOOL CPPgLists::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		byte ShowFileTypeIcon_old = m_pPrefs->ShowFileTypeIcon();
		byte ShowRatingIcons_old = m_pPrefs->ShowRatingIcons();

		m_pPrefs->SetA4AFStringEnabled(showA4AF);
		m_pPrefs->SetA4AFCountEnabled(showA4AFCount);
		m_pPrefs->SetShowAverageDataRate(showAvgDataRate);
		m_pPrefs->SetShowFileTypeIcon(showFileTypeIcons);
		m_pPrefs->SetTransferredOnCompleted(showTransferredOnCompleted);
		m_pPrefs->SetUseDwlPercentage(showDownloadPercentage);
		m_pPrefs->SetShowPausedGray(showPausedGray);
		m_pPrefs->SetShowFullFileStatusIcons(showFileStatusIcons);
		m_pPrefs->SetShowCountryFlag(showCountryFlag);
		m_pPrefs->SetShowRoundSizes(roundSizes);
		m_pPrefs->SetSmartFilterMaxQueueRank(_tstoi(strSmartFilterMaxQR));
		m_pPrefs->SetSmartFilterShowOnQueue(bSmartFilterShowSourcesOQ);
		m_pPrefs->SetShowRatingIcons(showRatingIcons);

		if ((ShowFileTypeIcon_old != (byte)m_pPrefs->ShowFileTypeIcon()) ||
			(ShowRatingIcons_old != (byte)m_pPrefs->ShowRatingIcons()))
		{
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.Invalidate();
			g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.Invalidate();
		}

		if (m_pPrefs->GetShowCountryFlag())
			g_eMuleApp.m_pIP2Country->Load();
		else
			g_eMuleApp.m_pIP2Country->Unload();

		if(m_pPrefs->IsUploadPartsEnabled()==!displayUploadParts)
		{
			m_pPrefs->SetUploadPartsEnabled(displayUploadParts);

			if(m_pPrefs->IsUploadPartsEnabled())
			{
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlUploadList.ShowColumn(8);
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlQueueList.ShowColumn(4);		
			}
			else
			{
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlUploadList.HideColumn(8);
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlQueueList.HideColumn(4);		
			}
		}

		g_eMuleApp.m_pIP2Country->Refresh();

		m_pPrefs->SetFakeListDownloadColor(m_FakeListColorButton.GetColor());

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgLists::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_LISTS));
		showA4AFCheck.SetWindowText(GetResString(IDS_A4AF));
		showA4AFCountCheck.SetWindowText(GetResString(IDS_A4AFCOUNT));
		showAvgDataRateCheck.SetWindowText(GetResString(IDS_SHOWAVGDATARATE));
		showFileTypeIconsCheck.SetWindowText(GetResString(IDS_SHOWFTYPE));
		showTransferredOnCompletedCheck.SetWindowText(GetResString(IDS_SHOWTRANFONCMPLT));
		showDownloadPercentageCheck.SetWindowText(GetResString(IDS_SHOWDWLPERCENTAGE));
		showPausedGrayCheck.SetWindowText(GetResString(IDS_SHOWGRAY));
		showFileStatusIconsCheck.SetWindowText(GetResString(IDS_STATUSICONS));
		showCountryFlagCheck.SetWindowText(GetResString(IDS_PW_SHOWCOUNTRYFLAG));
		roundSizesCheck.SetWindowText(GetResString(IDS_ROUNDSIZES));
		displayUploadPartsCheck.SetWindowText(GetResString(IDS_UPLOADPARTS));
		SmartFilterShowSourcesOQCheck.SetWindowText(GetResString(IDS_SMARTFILTER_SHOWOQ));
		SmartFilterMaxQRLabel.SetWindowText(GetResString(IDS_SMARTFILTER_MAXQR));
		GetResString(&strSmartFilterDesc, IDS_SRCFILTERMENU_SMARTFILTER);
		showRatingIconsCheck.SetWindowText(GetResString(IDS_SHOWRATINGICONS));
		m_FakeListColorButton.CustomText = GetResString(IDS_COL_MORECOLORS);
		m_FakeListColorButton.DefaultText = GetResString(IDS_COL_AUTOMATIC);
		GetResString(&strFakeListColorLabel, IDS_FAKELIST_COLOR_STATIC);

		UpdateData(FALSE);
	}
}
